
extern int length = 100;   // The amount of bars sent to be processed
string nameData;

int start()
{
   nameData = Symbol()+Period()+".csv";         // name of the data file to be sent
   static int old_bars;   // remember the amount of bars already known   
   while(!IsStopped())
   {   
   if (old_bars != Bars-1)      // if a new bar is received 
   {
        int handle = FileOpen(nameData, FILE_CSV|FILE_READ,';');
        if(handle<0)createFile();else{
         FileClose(handle);
        handle = FileOpen(nameData, FILE_CSV|FILE_READ|FILE_WRITE,';');
        int count=0;
        while(!FileIsEnding(handle)){
        FileReadString(handle);
        if(FileIsLineEnding(handle))count++;
        }
        FileSeek(handle,0,SEEK_SET);
        int recount = 0;
        while(!FileIsEnding(handle)){
        FileReadString(handle);
        if(FileIsLineEnding(handle)){
        recount++;
        if(recount==count-2){
        FileSeek(handle,0,SEEK_END);
        if(StrToTime(FileReadString(handle)+FileReadString(handle))!=Time[1])FileWrite(handle, TimeToStr(Time[1], TIME_DATE), TimeToStr(Time[1], TIME_SECONDS), High[1], Low[1], Close[1], Open[1], Volume[1]);
        }}
        }
        FileClose(handle);                            
        }
                                    
   }      
   old_bars = Bars-1;              // remember how many bars are known
   Sleep(30000);
   }
   return(0);
}

void createFile()
{
    int handle = FileOpen(nameData, FILE_CSV|FILE_WRITE,';');
        if(handle < 1)
        {
          Comment("Creation of "+nameData+" failed. Error #", GetLastError());
          return(0);
        }
        FileWrite(handle, ServerAddress(), Symbol(), Period());                  // heading
        FileWrite(handle, "DATE","TIME","HIGH","LOW","CLOSE","OPEN","VOLUME");   // heading
        int i;
        for (i=length-1; i>=0; i--)
        {
          FileWrite(handle, TimeToStr(Time[i], TIME_DATE), TimeToStr(Time[i], TIME_SECONDS),
                            High[i], Low[i], Close[i], Open[i], Volume[i]);
        }
        FileClose(handle);
        Print("File "+nameData+" has been created. "+TimeToStr(TimeCurrent(), TIME_SECONDS) );
}

